
-- return the window size
getWindowSize = getWindowSize or function()
	return 510, 220
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()
	setBannerContent( "nameOnly", 20, 200 )

	-- constants
	local kKnobSpace = 65
	local kKnobSpaceV = 70
	local kDropdownW = 90
	local kButtonW = 50
	local kTextW = 40

	local function knobGroup( LR, title )
		g = group( title )
		
		x = 0
		y = 0
		
		smallKnobAndTextField( g, "Level " .. LR,				"Level",			x, y )
		x = x + kKnobSize + 10
		x = x + 0.5*kKnobSpace

		labelledDropDown( g, "Mode " .. LR, "Mode", x, y, kDropdownW )
		x = x + kDropdownW + pad
		x = x + 0.5*kKnobSpace

		g:add( paramButton( "Bipolar " .. LR,					"Bipolar",			x, y, kButtonW, 30 ) )
		x = x + kButtonW + pad
		smallKnobAndTextField( g, "Scale " .. LR,				"Scale",			x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "ES-2 Offset " .. LR,			"ES-2 Offset",		x, y, kTextW )
		x = x + kKnobSpace
		smallKnobAndTextField( g, "Smoothing " .. LR,			"Smooth",			x, y, kTextW )
		x = x + kKnobSpace
		
		return g
	end

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0*kKnobSpace, 0 )
	miscGroup:setVisible( false )

	leftGroup = knobGroup( "L", "Left Channel" )
	rightGroup = knobGroup( "R", "Right Channel" )

	es2Group = group( "ES-2" )
	es2Group:setVisible( false )
	smallKnobAndTextField( es2Group, "ES-2 Filter Freq",	"Filter F",		0*kKnobSpace, 0 )
	smallKnobAndTextField( es2Group, "ES-2 Centre",			"Centre",		1*kKnobSpace, 0 )
	smallKnobAndTextField( es2Group, "ES-2 Tau 1",			"Tau 1",		2*kKnobSpace, 0 )
	smallKnobAndTextField( es2Group, "ES-2 Tau 2",			"Tau 2",		3*kKnobSpace, 0 )
	smallKnobAndTextField( es2Group, "ES-2 Force Smooth",	"Force Smth",	4*kKnobSpace, 0 )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase
	
	rightGroup:setPosition( x, y, true )
	x = x + rightGroup:width() + pad

	local prefsX = x
	
	miscGroup:setPosition( x, y, true )
	x = x + miscGroup:width() + pad
	
	x = xbase
	y = y + rightGroup:height() + pad
	
	leftGroup:setPosition( x, y, true )
	x = x + leftGroup:width() + pad
	
	local prefsY = y + pad

	x = xbase
	y = ybase

	es2Group:setPosition( x, y, true )
	x = x + es2Group:width() + pad

	-- add directly positioned objects
	--

	-- add the prefs button
	
	x = prefsX
	y = prefsY

	local ww, wh = getWindowSize()
	toggleES2ControlsButton = luaButton( toggleES2Controls, "", "Show/Hide ES-2 Config", "toggle", ww-5, y, 5, 30 )
	add( toggleES2ControlsButton )

end		-- of createUI()

function toggleES2Controls()
	local v = toggleES2ControlsButton:getState()
	es2Group:setVisible( v )
	v = not v
	leftGroup:setVisible( v )
	rightGroup:setVisible( v )
	redrawLabels()
end
